CSequenceFrame = 
{
    m_tblPaths = nil;
    m_tblSampl = nil;
    m_fTotTime = 0;
    m_fCurTime = 0;
    m_nFps     = 0;
};

function CSequenceFrame.new( tblPhotoPath, nFps, bInit )
    local self = {};
    setmetatable( self, CSequenceFrame );
    CSequenceFrame.__index = CSequenceFrame;

    local nPhotoCount = #tblPhotoPath;
    self.m_tblPaths = {};
    self.m_tblSampl = {};
    self.m_fTotTime = nPhotoCount / nFps * 1000;
    self.m_nFps = nFps;

    for i = 1, nPhotoCount do
        self.m_tblPaths[i] = tblPhotoPath[i];
    end

    for nCurFps = 0, nPhotoCount - 1 do
        self:__InitFrame( nCurFps );
    end

    return self;
end

function CSequenceFrame:__InitFrame( nCurFps )
    nCurFps = nCurFps + 1;
    if self.m_tblSampl[nCurFps] ~= nil then
        return;
    end
    local pSampler = Texture.Sampler.create( self.m_tblPaths[nCurFps] );
    self.m_tblSampl[nCurFps] = pSampler;
end

function CSequenceFrame:Reset()
    self.m_fCurTime = 0;
end

function CSequenceFrame:Update( nDeltaTime )
    self.m_fCurTime = ( self.m_fCurTime + nDeltaTime ) % self.m_fTotTime;
end

function CSequenceFrame:GetSampler()
    local fCurTime = self.m_fCurTime / 1000;
    local nCurFps = math.floor( fCurTime * self.m_nFps );
    self:__InitFrame( nCurFps );
    return self.m_tblSampl[nCurFps + 1];
end

function CSequenceFrame:GetCurTime()
    return self.m_fCurTime;
end

function CSequenceFrame:GetTolTime()
    return self.m_fTotTime;
end