-- 嘟嘴
function IsKiss( face )
    local vhRatioL = face:getFacePoint( 54, 310 ):distance( face:getFacePoint( 76, 310 ) )
        / face:getFacePoint( 50, 310 ):distance( face:getFacePoint( 62, 310 ) );
    local vhRatioR = face:getFacePoint( 54, 310 ):distance( face:getFacePoint( 76, 310 ) )
        / face:getFacePoint( 58, 310 ):distance( face:getFacePoint( 62, 310 ) );
    local inlineRatio = face:getFacePoint( 62, 310 ):distance( face:getFacePoint( 69, 310 ) )
        / face:getFacePoint( 54, 310 ):distance( face:getFacePoint( 76, 310 ) );
    local v = face:getFacePoint( 50, 310 ):distance( face:getFacePoint( 58, 310 ) )
        / face:getFacePoint( 44, 310 ):distance( face:getFacePoint( 47, 310 ) );
    return (inlineRatio < 0.25
        and vhRatioL > 1.04
        and vhRatioR > 1.04
        and math.abs( vhRatioL - vhRatioR ) < 0.15
        and v < 1.20);
end

-- 张嘴
function IsMouthOpened( face, fParam )
    if fParam == nil then fParam = 0.35; end
    local a = face:getFacePoint( 62, 310 ):distance( face:getFacePoint( 69, 310 ) );
    local b = face:getFacePoint( 50, 310 ):distance( face:getFacePoint( 58, 310 ) );
    return a / b >= fParam;
end

-- 左眨眼
function IsLeftEyeBlinked( face, fParam )
    if fParam == nil then fParam = 1; end
    -- 左眼的识别点为：4，5，6，7，8
    -- fixed by hrx 20161028 暂时用上下尺寸与左右尺寸的比例来判断，避免不同脸型及不同尺寸图片造成的上下差值不对的问题
    -- 正常上下的大小和眼睛的左右的一半左右
    local currentRadioValue = ( face:getFacePoint( 7, 310 ):y() - face:getFacePoint( 2, 310 ):y() )
        / ( face:getFacePoint( 0, 310 ):x() - face:getFacePoint( 5, 310 ):x() );
    return math.abs( currentRadioValue ) < 0.14 * fParam;
end

-- 右眨眼
function IsRightEyeBlinked( face, fParam )
    if fParam == nil then fParam = 1; end
    -- 右眼的识别点为：13，14，15，16，17
    local currentRadioValue = ( face:getFacePoint( 18, 310 ):y() - face:getFacePoint( 13, 310 ):y() )
        / ( face:getFacePoint( 10, 310 ):x() - face:getFacePoint( 15, 310 ):x() );
    return math.abs( currentRadioValue ) < 0.14 * fParam;
end

function IsEyeBlinked( face )
    return IsLeftEyeBlinked( face ) or IsRightEyeBlinked( face );
end

-- 微笑
function IsSmile( face )
    local headPos = face:getPosEstimator();
    local t = Vector3.new();
    local r = Quaternion.new();
    local s = Vector3.new();
    headPos:decompose( s, r, t);

    local p127 = face:getFacePoint(127, 310)
    local p147 = face:getFacePoint(147, 310)
    local p54 = face:getFacePoint(54, 310)
    local p76 = face:getFacePoint(76, 310)	
    local p50 = face:getFacePoint(50, 310)
    local p58 = face:getFacePoint(58, 310)	
    local p93 = face:getFacePoint(93, 310)
    local p103 = face:getFacePoint(103, 310)	

    local v0 = Vector2.new()
    local v1 = Vector2.new()
    local v2 = Vector2.new()
    local hand_y = r:y()

    Vector2.subtract(p127, p147, v0)
    Vector2.subtract(p54, p76, v1)
    local degree = v1:length() / v0:length() 
    
    degree = (degree - 0.25)/(1 - 0.25)

    Vector2.subtract(p54, p76, v0)
    Vector2.subtract(p50, p58, v1)
    Vector2.subtract(p93, p103, v2)
    
    
    local degree2 = v1:length() / v2:length()
    --姿态减少扭头时数值的误差
    if hand_y > 0 then
        degree2 = degree2 + hand_y/3
    else
        degree2 = degree2 - hand_y/3
    end

    local smile = 0.55; --系数越小越灵敏
    
    local open = 2; --越小张大嘴加分越多

    degree2 = (degree2 - 0.46)/(smile - 0.46)

    --增加张嘴的加分
    degree2 = degree2 + degree/open

    if degree2 >= 0.9 then
        return true;
    end
    return false;
end